from src.test.CTest.common.base import Base


class EnvConfig(Base):
    def create_env(self, env_name, system_tree_id, env_url, env_ip, env_port, env_type_id):
        data = {
            "name": env_name,
            "system": system_tree_id,
            "accessUrl": env_url,
            "ip": env_ip,
            "port": env_port,
            "type": env_type_id
        }
        create_env_url = self.devops_url + "/ms/ctest/api/user/environment"
        print(create_env_url)
        r = self.session.post(url=create_env_url, json=data)
        return r

    def edit_env(self, env_id, env_name, system_tree_id, env_url, env_ip, env_port, env_type_id):
        data = {
            "id": env_id,
            "name": env_name,
            "system": system_tree_id,
            "accessUrl": env_url,
            "ip": env_ip,
            "port": env_port,
            "type": env_type_id
        }
        edit_env_url = self.devops_url + "/ms/ctest/api/user/environment"
        print(edit_env_url)
        r = self.session.put(url=edit_env_url, json=data)
        return r

    def get_env_detail(self, env_id):
        env_detail_url = self.devops_url + "/ms/ctest/api/user/environment" + env_id
        print(env_detail_url)
        r = self.session.get(url=env_detail_url)
        return r

    def get_env_list(self, page_num, page_size, system_id_list, env_type_list, search_name):
        data = {
            "page": page_num,
            "pageSize": page_size,
            "systems": [system_id_list],
            "types": [env_type_list],
            "keyWord": search_name
        }
        get_env_list_url = self.devops_url + "/ms/ctest/api/user/environment/query"
        print(get_env_list_url)
        r = self.session.post(url=get_env_list_url, json=data)
        return r

    def delete_env(self, env_id):
        data = [env_id]
        delete_env_url = self.devops_url + "/ms/ctest/api/user/environment/delete"
        print(delete_env_url)
        r = self.session.post(url=delete_env_url, json=data)
        return r

    def adjust_env_unique(self, env_name):
        params = {
            "keyWord": env_name
        }
        adjust_env_unique_url = self.devops_url + "/ms/ctest/api/user/environment/unique"
        print(adjust_env_unique_url)
        r = self.session.get(url=adjust_env_unique_url, params=params)
        return r

    def enable_env(self, env_id):
        """
        启用或禁用测试环境
        :param env_id: 测试环境id
        enable：true为启用；false为禁用
        :return:
        """
        params = {
            "id": env_id,
            "enable": ""
        }
        enable_env_url = self.devops_url + "/ms/ctest/api/user/environment"
        print(enable_env_url)
        r = self.session.get(url=enable_env_url, params=params)
        return r

    def add_env_type(self, env_type_id, env_type_name):
        data = {
            "envTypeDTOS": [{
                "id": env_type_id,
                "name": env_type_name
            }],
            "ids": env_type_id
        }
        add_env_type_url = self.devops_url + "/ms/ctest/api/user/environment/type"
        print(add_env_type_url)
        r = self.session.post(url=add_env_type_url, json=data)
        return r

    def get_env_type_list(self):
        get_env_type_list_url = self.devops_url + "/ms/ctest/api/user/environment/type"
        print(get_env_type_list_url)
        r = self.session.get(url=get_env_type_list_url)
        return r
