import pytest

from src.test.CTest.pages.env_config import EnvConfig
from src.test.CTest.pages.system_tree import SystemTree


class TestEnvConfig:
    def setup_class(self):
        self.system_tree = SystemTree()
        self.env = EnvConfig()

    def test_create_system_tree(self):
        # 创建系统功能树
        r1 = self.system_tree.create_system_tree(name="test_env_专用系统", tree_type="SYSTEM", parent_id="")
        print(r1.text)

    def test_add_env_type(self):
        # 创建环境类型
        r1 = self.env.add_env_type(env_type_id=None, env_type_name="add_env")
        assert r1.status_code == 200 and r1.json()["status"] == 0 and r1.json()["data"] == True
        print("成功添加测试环境类型env_test，接口返回如下：", r1.text)
        r2 = self.env.get_env_type_list()
        print(r2.text)

    def test_create_env(self):
        # 创建环境类型
        # r2 = self.env.add_env_type(env_type_id=None, env_type_name="test_env（专用）")
        # print(r2.text)
        # env_type_list = self.env.get_env_type_list().json()["data"]
        # print(env_type_list)
        # env_type_id = [item['id'] for item in env_type_list if item['name'] == "test_env（专用）"]
        # print(env_type_id)
        # print(type(env_type_id))
        # 创建测试环境（依赖于系统功能树、测试环境类型的数据）
        r2 = self.env.create_env()

    def test_edit_env(self):
        pass

    def test_get_env_detail(self):
        pass

    def test_get_env_list(self):
        pass

    def test_delete_env(self):
        pass

    def test_enable_env(self):
        pass

    def test_edit_env_type(self):
        r1 = self.env.add_env_type(env_type_id=None, env_type_name="edit_env")
        assert r1.status_code == 200 and r1.json()["status"] == 0 and r1.json()["data"] == True
        env_type_list = self.env.get_env_type_list().json()["data"]
        # 获取环境类型名称为"edit_env"的id，然后进行编辑修改名称
        env_type_id = [item['id'] for item in env_type_list if item['name'] == "edit_env"]
        print("修改环境类型的id为：", env_type_id[0])
        r2 = self.env.add_env_type(env_type_id=env_type_id[0], env_type_name="edit_env--修改")
        # assert r2.status_code == 200 and r2.json()["status"] == 0 and r2.json()["data"] == True
        print(r2.text)
